searchNodes=[{"doc":"TimeZoneInfo provides a time zone database for Elixir using the data from the the Internet Assigned Numbers Authority (IANA).Therefore TimeZoneInfo contains an implementation of the Calendar.TimeZoneDatabase behaviour under TimeZoneInfo.TimeZoneDatabase.","ref":"TimeZoneInfo.html","title":"TimeZoneInfo","type":"module"},{"doc":"Generates TimeZoneInfo.data from the given iana_data_archive.","ref":"TimeZoneInfo.html#data/2","title":"TimeZoneInfo.data/2","type":"function"},{"doc":"Returns the version of the IANA database.","ref":"TimeZoneInfo.html#iana_version/0","title":"TimeZoneInfo.iana_version/0","type":"function"},{"doc":"Returns infos about persisted and stored data.","ref":"TimeZoneInfo.html#info/0","title":"TimeZoneInfo.info/0","type":"function"},{"doc":"Returns the date time in UTC for the next update. Retruns :never if the automated update disabled.","ref":"TimeZoneInfo.html#next_update/0","title":"TimeZoneInfo.next_update/0","type":"function"},{"doc":"Returns the state of TimeZoneInfo.Returns:ok if everything runs normal and the automated update is disabled.{:next, seconds} if everything runs normal.{:error, reason} in case of an error.","ref":"TimeZoneInfo.html#state/0","title":"TimeZoneInfo.state/0","type":"function"},{"doc":"Returns the list of all available time zones with or without links. The option :links can be used to customize the list.Values for :links::ignore just the time zone names will be returned:only just the link names will be returned:include the time zone and link names will be returned (default)The list will be sorted.","ref":"TimeZoneInfo.html#time_zones/1","title":"TimeZoneInfo.time_zones/1","type":"function"},{"doc":"Triggers the update process. Withe the opt :force the update will be forced.","ref":"TimeZoneInfo.html#update/1","title":"TimeZoneInfo.update/1","type":"function"},{"doc":"The data structure containing all informations for TimeZoneInfo.","ref":"TimeZoneInfo.html#t:data/0","title":"TimeZoneInfo.data/0","type":"type"},{"doc":"The configuration for data generation.:files: The list of files from the IANA DB download.:time_zones: The list of time zones that will be used. The atom :all indicates that all time zones from the IANA DB will be used.:lookahead: Number of years for which data are precalculated.See Config page for more information.","ref":"TimeZoneInfo.html#t:data_config/0","title":"TimeZoneInfo.data_config/0","type":"type"},{"doc":"Seconds since year 0 in the gregorian calendar.","ref":"TimeZoneInfo.html#t:gregorian_seconds/0","title":"TimeZoneInfo.gregorian_seconds/0","type":"type"},{"doc":"A rule representation.","ref":"TimeZoneInfo.html#t:rule/0","title":"TimeZoneInfo.rule/0","type":"type"},{"doc":"The name of a rule set that can be found in the IANA data.","ref":"TimeZoneInfo.html#t:rule_name/0","title":"TimeZoneInfo.rule_name/0","type":"type"},{"doc":"A reference to a rule set. The reference also contains utc_offset and format, The reference contains utc_offset and format because these values are needed to apply a rule.","ref":"TimeZoneInfo.html#t:rules_ref/0","title":"TimeZoneInfo.rules_ref/0","type":"type"},{"doc":"The time standards used by IANA.","ref":"TimeZoneInfo.html#t:time_standard/0","title":"TimeZoneInfo.time_standard/0","type":"type"},{"doc":"A period where a certain combination of UTC offset, standard offset and zone abbreviation is in effect. The wall_period contains the start and end of the time zone period in wall time.","ref":"TimeZoneInfo.html#t:time_zone_period/0","title":"TimeZoneInfo.time_zone_period/0","type":"type"},{"doc":"","ref":"TimeZoneInfo.html#t:time_zones/0","title":"TimeZoneInfo.time_zones/0","type":"type"},{"doc":"A transition marks a point in time when one or more of the values utc-offset, std_offset or zone-abbr change.","ref":"TimeZoneInfo.html#t:transition/0","title":"TimeZoneInfo.transition/0","type":"type"},{"doc":"The wall time period represented in a tuple with two naive date times.","ref":"TimeZoneInfo.html#t:wall_period/0","title":"TimeZoneInfo.wall_period/0","type":"type"},{"doc":"The zone_state is either a timezone_period or a rules_ref.","ref":"TimeZoneInfo.html#t:zone_state/0","title":"TimeZoneInfo.zone_state/0","type":"type"},{"doc":"Implementation of the Calendar.TimeZoneDatabase behaviour.","ref":"TimeZoneInfo.TimeZoneDatabase.html","title":"TimeZoneInfo.TimeZoneDatabase","type":"module"},{"doc":"A behaviour to persist the data.","ref":"TimeZoneInfo.DataPersistence.html","title":"TimeZoneInfo.DataPersistence","type":"behaviour"},{"doc":"Returns the checksum for the persisted data.","ref":"TimeZoneInfo.DataPersistence.html#c:checksum/0","title":"TimeZoneInfo.DataPersistence.checksum/0","type":"callback"},{"doc":"Returns the persisted data.","ref":"TimeZoneInfo.DataPersistence.html#c:fetch/0","title":"TimeZoneInfo.DataPersistence.fetch/0","type":"callback"},{"doc":"Returns the timestamp of the last update in seconds since epoch.","ref":"TimeZoneInfo.DataPersistence.html#c:fetch_last_update/0","title":"TimeZoneInfo.DataPersistence.fetch_last_update/0","type":"callback"},{"doc":"Returns infos about the persisted data.","ref":"TimeZoneInfo.DataPersistence.html#c:info/0","title":"TimeZoneInfo.DataPersistence.info/0","type":"callback"},{"doc":"Persists the given data.","ref":"TimeZoneInfo.DataPersistence.html#c:put/1","title":"TimeZoneInfo.DataPersistence.put/1","type":"callback"},{"doc":"Sets time as last update time stamp. time is given in seconds since epoch.","ref":"TimeZoneInfo.DataPersistence.html#c:put_last_update/1","title":"TimeZoneInfo.DataPersistence.put_last_update/1","type":"callback"},{"doc":"The behaviour for downloaders.","ref":"TimeZoneInfo.Downloader.html","title":"TimeZoneInfo.Downloader","type":"behaviour"},{"doc":"","ref":"TimeZoneInfo.Downloader.html#c:download/2","title":"TimeZoneInfo.Downloader.download/2","type":"callback"},{"doc":"","ref":"TimeZoneInfo.Downloader.html#t:download/0","title":"TimeZoneInfo.Downloader.download/0","type":"type"},{"doc":"HTTP headers.","ref":"TimeZoneInfo.Downloader.html#t:headers/0","title":"TimeZoneInfo.Downloader.headers/0","type":"type"},{"doc":"The mode to download the data.Possible modes::iana downloads the data as a zipped tar archive in IANA format.:etf downloads the data as a compressed file in the TimeZoneInfo External Term Format.:ws downloads the data from a web service. In this mode, the configuration is sent to the server. The returned data is transformed according to the config on the server and comes in the same format as in the mode :etf.","ref":"TimeZoneInfo.Downloader.html#t:mode/0","title":"TimeZoneInfo.Downloader.mode/0","type":"type"},{"doc":"","ref":"TimeZoneInfo.Downloader.html#t:opts/0","title":"TimeZoneInfo.Downloader.opts/0","type":"type"},{"doc":"HTTP status code","ref":"TimeZoneInfo.Downloader.html#t:status_code/0","title":"TimeZoneInfo.Downloader.status_code/0","type":"type"},{"doc":"A behaviour for TimeZoneInfo listeners.","ref":"TimeZoneInfo.Listener.html","title":"TimeZoneInfo.Listener","type":"behaviour"},{"doc":"A callback to listen on the update process.Possible events::initial initializing data.:check checking whether an update is necessary.:force an update is forced.:download downloads data.:update updating data.{:error, reason}","ref":"TimeZoneInfo.Listener.html#c:on_update/1","title":"TimeZoneInfo.Listener.on_update/1","type":"callback"},{"doc":"An implementation for the behaviour TimeZoneInfo.DataPersistence to persist data in the file system.","ref":"TimeZoneInfo.DataPersistence.FileSystem.html","title":"TimeZoneInfo.DataPersistence.FileSystem","type":"module"},{"doc":"An implementation for the behaviour TimeZoneInfo.DataPersistence to persist data in the priv dir.","ref":"TimeZoneInfo.DataPersistence.Priv.html","title":"TimeZoneInfo.DataPersistence.Priv","type":"module"},{"doc":"An implementation of the TimeZoneInfo.Downloader behaviour using Mint.","ref":"TimeZoneInfo.Downloader.Mint.html","title":"TimeZoneInfo.Downloader.Mint","type":"module"},{"doc":"A listener to log TimeZoneInfo errors.This is the default implementation of the TimeZoneInfo.Listener.","ref":"TimeZoneInfo.Listener.ErrorLogger.html","title":"TimeZoneInfo.Listener.ErrorLogger","type":"module"},{"doc":"A listener to log TimeZoneInfo events.","ref":"TimeZoneInfo.Listener.Logger.html","title":"TimeZoneInfo.Listener.Logger","type":"module"},{"doc":"TimeZoneInfo Time zone support for Elixir by using the IANA Time Zone Database.","ref":"readme.html","title":"TimeZoneInfo","type":"extras"},{"doc":"The package can be installed by adding time_zone_info to your list of dependencies in mix.exs:def deps do [ {:time_zone_info, &quot;~&gt; 0.5&quot;} ] end","ref":"readme.html#installation","title":"TimeZoneInfo - Installation","type":"extras"},{"doc":"After installation, TimeZoneInfo can be used as follows.iex&gt; TimeZoneInfo.iana_version &quot;2020d&quot; iex&gt; TimeZoneInfo.time_zones() |&gt; Enum.take(3) [&quot;Africa/Abidjan&quot;, &quot;Africa/Accra&quot;, &quot;Africa/Addis_Ababa&quot;] iex&gt; TimeZoneInfo.period_from_utc(~N[2020-03-29 01:30:00], &quot;Europe/Berlin&quot;) {:ok, {3600, 3600, &quot;CEST&quot;}}In combination with DateTime and Calendar:iex&gt; {:ok, berlin} = DateTime.from_naive( ...&gt; ~N[2020-03-29 01:30:00], ...&gt; &quot;Europe/Berlin&quot;, ...&gt; TimeZoneInfo.TimeZoneDatabase) {:ok, #DateTime&lt;2020-03-29 01:30:00+01:00 CET Europe/Berlin&gt;} iex&gt; Calendar.put_time_zone_database(TimeZoneInfo.TimeZoneDatabase) :ok iex&gt; DateTime.shift_zone(berlin, &quot;America/New_York&quot;) {:ok, #DateTime&lt;2020-03-28 20:30:00-04:00 EDT America/New_York&gt;}Instead of the line Calendar.put_time_zone_database(TimeZoneInfo.TimeZoneDatabase) you can also specify the following entry in the configuration.config :elixir, :time_zone_database, TimeZoneInfo.TimeZoneDatabaseFor more information how to configure TimeZoneInfo see Config. The site shows how to enable automated updates, filter time zones, and add custom behaviours.","ref":"readme.html#usage","title":"TimeZoneInfo - Usage","type":"extras"},{"doc":"The default configuration of TimeZoneInfo is updater: :disabled. In this case, the IANA database in version 2020d with a lookahead of 15 years is in use.If a time zone has continuation rules, the periods after the lookahead are calculating by these rules. Note, these calculations are much more expensive as the determination of periods inside the prepared time span.","ref":"readme.html#default-time-zone-data","title":"TimeZoneInfo - Default Time Zone Data","type":"extras"},{"doc":"The benchmarks can be executed with mix bench.Benchmarks:A benchmark to compare TimeZoneInfo with Tzdata and Tz for the execution of TimeZoneDatabase.time_zone_periods_from_wall_datetime/2.A benchmark to compare different TimeZoneInfo.DataStores.A benchmark to measure the speed of the transformation of the raw IANA data to the required data in runtime.","ref":"readme.html#benchmarks","title":"TimeZoneInfo - Benchmarks","type":"extras"},{"doc":"There are some differences to Tzdata and Tz. The list shows differences to Tzdata and/or Tz.Use of :persitent_term with an optional use of :ets.Persisting data in External Term FormatThe data persisting is customizable by the behaviour TimeZoneInfo.DataPersistence.Optional download of time zone data in TimeZoneInfo format.The download is customizable by the behaviour TimeZoneInfo.Downloader.Filter time zones per config.Optional listener that will be called on updates.TimeZoneInfo calculates periods in the far future by continuation rules. Except for time zones that have daylight saving times for Ramadan.","ref":"readme.html#differences-to-tzdata-and-tz","title":"TimeZoneInfo - Differences to Tzdata and Tz","type":"extras"},{"doc":"The home of the IANA Time Zone Database: https://www.iana.org/time-zonesLinks:Time zone - Wikipediatimeanddate.comWorldTimeServer.comOther Elixir implementations:tzdata - Tzdata is a parser and library for the tz database.tz - Time zone support for ElixirOther implementations:DateTime::TimeZone - PerlTimeZoneInfo use this module as a checker in the tests.NodaTime - A better date and time API for .NETTimeZonInfo use some data from this site in the tests.","ref":"readme.html#references","title":"TimeZoneInfo - References","type":"extras"},{"doc":"ConfigAdd the following line to use TimeZoneInfo per default in the project.config :elixir, :time_zone_database, TimeZoneInfo.TimeZoneDatabase","ref":"config.html","title":"Config","type":"extras"},{"doc":"The automated update uses the default Downloader, and this one uses Mint. Therefore the following dependencies are needed in mix.exs.defp deps do [ ... {:castore, &quot;~&gt; 0.1.0&quot;}, {:mint, &quot;~&gt; 1.0&quot;}, ... ] endThe config has to be extended with:config :time_zone_info, update: :daily","ref":"config.html#enable-automated-updates","title":"Config - Enable automated updates","type":"extras"},{"doc":"It is also possible to use your own downloader. This requires an implementation of the behaviour TimeZoneInfo.Downloader. The custom downloader has to be specified in the config.config :time_zone_info, [ update: :daily, downloader: [ module: MyApp.TimeZonInfo.Downloader, uri: &quot;https://data.iana.org/time-zones/tzdata-latest.tar.gz&quot;, mode: :iana, headers: [ {&quot;Content-Type&quot;, &quot;application/tar+gzip&quot;}, {&quot;User-Agent&quot;, &quot;Elixir.TimeZoneInfo.Mint&quot;} ] ], ]The option update specifies the update interval. Possible values are :daily and :disabled to disable the automated update.The keys uri and headers containing to download the data.The key mode can contain :iana, :etf, or :ws and indicates whether they data are delivered in IANA format (.tar.gz) or in zipped ETF (External Term Format).In :ws mode, the request for the data contains query parameters. The parameters are containing the configuration:files[]: A list of IANA files which are used to generate the TimeZoneInfo.data.time_zones[]: A list of time zones. These parameters do not apply if no time zones are specified.lookaheadThe response format in :ws mode is the same as in :etf mode.","ref":"config.html#custom-downloader","title":"Config - Custom downloader","type":"extras"},{"doc":"TimeZoneInfo provides some configuration options to select a subset form the available time zones and the size of the generated periods table.config :time_zone_info, ... files: ~w(europe asia), time_zones: ~w(Europe Asia/Istanbul), lookahead: 5files:Default: [&quot;africa&quot;, &quot;antarctica&quot;, &quot;asia&quot;, &quot;australasia&quot;, &quot;backward&quot;, &quot;etcetera&quot;, &quot;europe&quot;, &quot;northamerica&quot;, &quot;southamerica&quot;)This option specifies which files are parsed from the IANA data. The files europe, asia, etc are self-explanatory. The file ecetera contains time zones like Etc/UTC, Etc/Zulu, Etc/GMT+1, etc. The backward file contains obsolete time zones. If you do not need the obsolete time zones, configure a list without the backward file. Note: The configuration :files takes no effect if update: :disabled is set.time_zones:Default: :allWith time_zones: you can determine which time zones should be used. This configuration expected a list of time zone names and/or areas like [&quot;Asia&quot;, &quot;Europe/Berlin&quot;]. In this example all time zones in the area Asia and the time zone &quot;Europe/Berlin&quot; are available. If a time zone link matches the time_zones configuration, the linked time zone will be also be available. For example, if you set time_zones: [&quot;Europe/Jersey&quot;] then the time zone Europe/London is also available because Europe/Jersey links this time zone.lookahead:Default: 5The lookahead specifies for how many years from now the periods will be calculated.Note: They configuration :lookahead takes no effect if update: :disabled is set.","ref":"config.html#time-zone-manipulation","title":"Config - Time zone manipulation","type":"extras"},{"doc":"TimeZoneInfo has two implementations of the behaviour TimeZoneInfo.DataPersistence to persist data.TimeZoneInfo.DataPersistence.Priv is used in the default configuration.config :time_zone_info, ... data_persistence: TimeZoneInfo.DataPersistence.Priv, priv: [path: &quot;data.etf&quot;]This module is intended for simple configurations. The specified data.etf is part of the TimeZoneInfo package and contains the transformed data from the actual IANA time zone DB.TimeZoneInfo.DataPersistence.FileSystem stores the data in a file to be specified.config :time_zone_info, ... data_persistence: TimeZoneInfo.DataPersistence.FileSystem, file_system: [path: &quot;data/tzi.etf&quot;]","ref":"config.html#data-persistence","title":"Config - Data persistence","type":"extras"},{"doc":"TimeZoneInfo provides two methods to store data at runtime. The data can be stored either with :persistent_term or with :ets. The option data_store holds this configuration. With data_store: :detect (default) the method with :persistent_term will be used if :persitent_term is available (OTP &gt;= 21.2). To set a method explicitly use data_store: TimeZoneInfo.DataStore.PersistentTerm or data_store: TimeZoneInfo.DataStore.ErlangTermStorage.","ref":"config.html#the-data-store","title":"Config - The data store","type":"extras"},{"doc":"It is not recomented to update the configuration at runtime. Becaus the data in runtime will just be updated but never deleted. That means if you change time_zones: :all to time_zones: [&quot;Europe&quot;] then all time zones are available after an update.This is not a problem for the automated update. Because all period tables will be updated.","ref":"config.html#no-runtime-config-no-delete","title":"Config - No runtime config, no delete","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Updating priv/data.etf with IANA tzdata version 2020d.","ref":"changelog.html#0-5-1-2020-10-26","title":"Changelog - 0.5.1 - 2020/10/26","type":"extras"},{"doc":"Supporting different calendars.","ref":"changelog.html#0-5-1-2020-07-08","title":"Changelog - 0.5.1 - 2020/07/08","type":"extras"},{"doc":"Increasing speed of TimeZoneDatabase.time_zone_periods_from_wall_datetime/2.Adding wall_time to time_zone_period.Refactoring updater to fix some unexpected behaviours when changing configs.Updating docs structure.Adding backward to the default files.Refactoring time_zones configuration behaviour. See Time zone maniputlation.","ref":"changelog.html#0-5-0-2020-06-08","title":"Changelog - 0.5.0 - 2020/06/08","type":"extras"},{"doc":"Updating priv/data.etf with IANA tzdata version 2020a.The Etc/UTC time-zone is always supported, no matter how the configuration is specified.Adding TimeZoneInfo.DataPersistence.FileSystem.Changing configuration option format to mode.Adding mode :ws. In this mode the Downloader will call a web service to fetch data.Adding TimeZoneInfo.data/2, this function generates TimeZoneInfo.data and is intended for use in a time-zone-info-server.Adding examples TimeZoneInfoServer and Clock.Making some modules private. According to Hiding Internal Modules and Functions.","ref":"changelog.html#0-4-0-2020-04-25","title":"Changelog - 0.4.0 - 2020/04/25","type":"extras"},{"doc":"Using plug_cowboy instead of cowboy in tests.Adding HTTP status code to the downloader.Updating default lookahead to 15 years.Refactoring date time handling.Adding TimeZoneInfo.info/0.Adding optional info/0 callback to the DataStore behaviour.Adding optional info/0 callback to the DataPersistence behaviour.Adding TimeZoneInfo.Listener.ErrorLogger.","ref":"changelog.html#0-3-0-2020-04-15","title":"Changelog - 0.3.0 - 2020/04/15","type":"extras"},{"doc":"Reimplementation of the TimeZoneInfo.Transformer to fix a bunch of bugs.Update parser to handle CRs.","ref":"changelog.html#0-2-0-2020-04-08","title":"Changelog - 0.2.0 - 2020/04/08","type":"extras"},{"doc":"Fix github link in package.","ref":"changelog.html#0-1-1-2020-03-28","title":"Changelog - 0.1.1 - 2020/03/28","type":"extras"},{"doc":"Initial release.","ref":"changelog.html#0-1-0-2020-03-28","title":"Changelog - 0.1.0 - 2020/03/28","type":"extras"}]